#include "a.h"
#include <TGraph.h>
#include <TF1.h>
#include <TRandom.h>
#include <TList.h>
ClassImp(A)
//___________________________________________________________________
void A::Create()
{
	// Create a TF1 with a user function
	TF1 *fun = new TF1("MyFunc",A::FuncNPoint,0.,12.,2);
	fun->SetParameter(0,.001);
	fun->SetParameter(1,1.);

	// Create a TGraph with 10 points generated with above TF1 - add some scatter...
	Double_t x[10],y[10];
	TRandom r;
	for (int i=0;i<10;i++)
	{
		x[i] = i+1;
		y[i] = fun->Eval(x[i])*(1.+r.Gaus(0.,.1));
	}
	if (fG) delete fG;
	fG = new TGraph(10,x,y);

	// Now, attach the TF1 to the TGraph
	TList *list = fG->GetListOfFunctions();
	list->Add(fun);
}
//___________________________________________________________________
Double_t A::FuncNPoint(Double_t *x,Double_t *par)
{
	Double_t t = x[0];
	Double_t val = par[1]*t*t + par[2]/t;
	return val;
}
//___________________________________________________________________
A::~A()
{
	if (fG) delete fG;
}
//______________________________________________________________________________
void A::Streamer(TBuffer &R__b)
{
   // In my application I need custom streamer - just added for completeness

   UInt_t R__s, R__c;
   if (R__b.IsReading()) {
      Version_t R__v = R__b.ReadVersion(&R__s, &R__c); if (R__v) { }
      TObject::Streamer(R__b);
      R__b >> fG;
      R__b.CheckByteCount(R__s, R__c, A::IsA());

   } else {
      R__c = R__b.WriteVersion(A::IsA(), kTRUE);
      TObject::Streamer(R__b);
      R__b << fG;
      R__b.SetByteCount(R__c, kTRUE);
   }
}
